/***************************************************************************
                          list.cpp  -  description
                             -------------------
    begin                : ??? ??? 18 2004
    copyright            : (C) 2004 by Evgeny Kalugin
    email                : kalugin@ake-vg.spb.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "list.h"

#include <qptrvector.h>
#include <qlistbox.h>
#include <qhostaddress.h>
#include <qstring.h>
#include "currentchat.h"



List::List()
{
   number = 0;

   alias = new QPtrVector <QString>( MAXITEMS );
   ip = new QPtrVector <QHostAddress> ( MAXITEMS );
   list_box_items =  new QPtrVector <QListBoxItem> ( MAXITEMS );
   tab_widget_items = new QPtrVector <CurrentChat> ( MAXITEMS );
}

List::~List()
{

}

/** the number of contacts */
int List::count()
{
   return number;
}


int List::add( QHostAddress *new_ip )
{
    int i;

    for( i = 0; i < MAXITEMS; i++ )
    {
       if( ip->at( i ) == 0 )
       {
           break;
       }
    }


    ip->insert( i, new_ip );
    number++;
    return i;
}


void List::add( QString *new_alias, int i )
{
    alias->insert( i, new_alias );
}


void List::add( QListBoxItem *new_list_box_item, int i )
{
    list_box_items->insert( i, new_list_box_item );
}


void List::add( CurrentChat *new_current_chat, int i )
{
    tab_widget_items->insert( i, new_current_chat );
}

int List::del( int i )
{
    if( ( i < 0 ) || ( i >= MAXITEMS ) )
    {
       return 0;
    }

    ip->remove( i );
    alias->remove( i );
    list_box_items->remove( i );
    tab_widget_items->remove( i );

    number--;

    return 1;
}

int List::del( QHostAddress *elem )
{
    return this->del( this->getIndex( elem ) );
}

int List::del( CurrentChat *elem )
{
    return this->del( this->getIndex( elem ) );
}

int List::del( QListBoxItem *elem )
{
    return this->del( this->getIndex( elem ) );
}

int List::del( QString *elem )
{
    return this->del( this->getIndex( elem ) );
}




int List::getIndex( QHostAddress* new_ip ){

    for( int i = 0; i < MAXITEMS; i++ )
    {
       if( ip->at( i ) != 0 )
       {
           if( ip->at( i )->ip4Addr() == new_ip->ip4Addr() )
           {
              return i;
           }
       }
    }
    return -1;
}

int List::getIndex( QString* new_alias ){
    for( int i = 0; i < MAXITEMS; i++ )
    {
       if( alias->at( i ) != 0 )
       {
           if( *( alias->at( i ) ) == *new_alias )
           {
              return i;
           }
       }
    }
    return -1;
}

int List::getIndex( QListBoxItem* new_list_box_item ){
    return list_box_items->findRef( new_list_box_item );
}

int List::getIndex( CurrentChat* new_current_chat ){
    return tab_widget_items->findRef( new_current_chat );
}

QString* List::getAlias( int i )
{
    return alias->at( i );
}

QListBoxItem* List::getListBoxItem( int i )
{
    return list_box_items->at( i );
}

CurrentChat* List::getCurrentChat( int i )
{
    return tab_widget_items->at( i );
}

QHostAddress* List::getIP( int i )
{
    return ip->at( i );
}

int List::getTabIndex( int i )
{
    return tab_index[i];
}

void List::setTabIndex( int index, int i )
{
    tab_index[i] = index;
}
