/***************************************************************************
                          list.h  -  description
                             -------------------
    begin                : ??? ??? 18 2004
    copyright            : (C) 2004 by Evgeny Kalugin
    email                : kalugin@ake-vg.spb.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LIST_H
#define LIST_H


template<class type> class QPtrVector;

class QHostAddress;
class QListBoxItem;
class QString;
class CurrentChat;

const int MAXITEMS = 200;


class List {
public: 
    List();
    ~List();
    /** the number of contacts */
    int count();

    void add( CurrentChat*, int ) ;

    void add( QListBoxItem*, int );

    void add( QString*, int );

    int  add( QHostAddress* );



    int del( CurrentChat* );

    int del( QListBoxItem* );

    int del( QString* );

    int del( QHostAddress* );


    int getIndex( QListBoxItem* );

    int getIndex( QString* );

    int getIndex( QHostAddress* );

    int getIndex( CurrentChat* );

    CurrentChat* getCurrentChat( int );

    QListBoxItem* getListBoxItem( int );

    QString* getAlias( int );

    QHostAddress* getIP( int );

    int getTabIndex( int );

    void setTabIndex( int, int );

public: // Public attributes

protected:

    /** The list of actual ip addresses */
    QPtrVector<QHostAddress> *ip;
    /** The list of aliases associated with ip addresses */
    QPtrVector<QString> *alias;

    QPtrVector<QListBoxItem> *list_box_items;
    QPtrVector<CurrentChat> *tab_widget_items;

private:
    int del( int );

    int tab_index[MAXITEMS];
    int number;
};

#endif
