#ifndef SCHATCONTACTLIST_H
#define SCHATCONTACTLIST_H

#include <qvariant.h>
#include <qhostaddress.h>
#include <qmainwindow.h>

#include <qthread.h>

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class QListBox;
class QListBoxItem;
class QTabWidget;
class QWidget;


class SchatContactList : public QMainWindow, public QThread
{ 
    Q_OBJECT

public:
    SchatContactList( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
    ~SchatContactList();

    QTabWidget* tab_widget;
    QListBox* contact_list;
    QMenuBar *menu_bar;
    QPopupMenu *popup_menu;
    QPopupMenu *help_menu;
/*
    QAction* help_contents_action;
    QAction* help_index_action;
    QAction* help_about_action;
*/
    QAction* new_connection_dialog_action;
    QAction* delete_connection_action;
    QAction* opions_action;
    QAction* exit_action;



public slots:
    virtual void init();
    virtual void helpIndex();
    virtual void helpContents();
    virtual void helpAbout();



private slots:
    virtual void showDialog();

protected:

  /** This function adds IP address to contact list */
  virtual void newIPAddress( QHostAddress *new_address );
  void run();

    friend class NewContactDialog;
    NewContactDialog *contact_dialog;

    friend class CurrentChat;
    CurrentChat *current_chat;

    friend class List;
    List *list;

    friend class UnixSocket;
    UnixSocket *unix_socket;

public slots: // Public slots
  /** No descriptions */
  virtual void contactListDoubleClicked( QListBoxItem *list_box_item );
public slots: // Public slots
  /** slot, connected to messageReceived. This function handles received message */
  void messageHandle( QString *message, QHostAddress *from );
signals: // Signals
  /** signal, that message is received */
  void messageReceived( QString *message, QHostAddress *from );
};

#endif // SCHATCONTACTLIST_H
