/***************************************************************************
                          unixsocket.cpp  -  description
                             -------------------
    begin                : ??? ??? 19 2004
    copyright            : (C) 2004 by Evgeny Kalugin
    email                : kalugin@ake-vg.spb.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "unixsocket.h"

#include <unistd.h>
#include <stdio.h>

#include <qstring.h>
#include <qhostaddress.h>


UnixSocket::UnixSocket()
{
   struct sockaddr_un addr;

   sockfd = socket( AF_UNIX, SOCK_STREAM, 0 );

   if( !sockfd )
   {
       perror( "socket" );
   }

   addr.sun_family = AF_UNIX;
   strcpy( addr.sun_path, INT_SOCKET_PATH );


   if( connect( sockfd, ( struct sockaddr* )&addr, sizeof( addr ) ) != 0 )
   {
       perror( "connect" );
   }

}

UnixSocket::~UnixSocket()
{
    close( sockfd );
}

void UnixSocket::Receive( QString **message, QHostAddress **from )
{
    t_message_int msg;

    recv( sockfd, &msg, sizeof( msg ), 0 );


    *message = new QString( msg.message );
    *from = new QHostAddress( msg.ipaddr );

}
void UnixSocket::Send( QString *message, QHostAddress *to )
{

    t_message_int msg;


    sprintf( msg.message, "%s", message->latin1() );

    msg.ipaddr = to->ip4Addr();

    send( sockfd, &msg, strlen( msg.message ) + sizeof( msg.ipaddr ) + 1, 0 );

}

