/***************************************************************************
                          unixsocket.h  -  description
                             -------------------
    begin                : ??? ??? 19 2004
    copyright            : (C) 2004 by Evgeny Kalugin
    email                : kalugin@ake-vg.spb.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UNIXSOCKET_H
#define UNIXSOCKET_H

#include <sys/socket.h>
#include <sys/un.h>


#define INT_SOCKET_PATH   "/tmp/schat3538"
#define MAX_MESSAGE_SIZE  64*1024


typedef struct {
   u_int32_t ipaddr;
   char message[MAX_MESSAGE_SIZE];
} t_message_int;



class QString;
class QHostAddress;


/**This class provides operating with AF_UNIX sockets
  */

class UnixSocket
{
private:
    int sockfd;

protected:
    friend class SchatContactList;
    SchatContactList *contact_list;

public:
    UnixSocket();
    ~UnixSocket();
    void Receive( QString **message, QHostAddress **from );
    void Send( QString *message, QHostAddress *to );

};

#endif
