/***************************************************************************
                          schat_deamon.c  -  the Simple chat deamon
                              source code
    begin                :   21 2004
    copyright            : (C) 2004 by Evgeny Kalugin
    email                : kalugin@ake-vg.spb.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

#include <sys/poll.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>


#include "schat_deamon.h"


t_message_int message_int;
t_message_ext message_ext;

int ext_socket, int_socket;

struct pollfd sockets[2];
int pollres;

int e;
int y0;

int n_int_msg, n_ext_msg;


extern int init_int_socket( void );
extern int init_ext_socket( void );



void z0( void );
void z1( void );
void z2( void );
void z3( void );
void z4( void );
void z5( void );
void z6( void );
void z7( void );



void log( void ) {
 
   
   if( e != -1 ) {
      printf( " e%d                 :   ", e );
   }

   switch( e ) {
      case 0:
         printf( "    \n" );
         break;
      case 1:
         printf( "    \n" );
         break;
      case 2:
         printf( "     \n" );
         break;
      case 3:
         printf( "     \n" );
         break;
      case 4:
         printf( "    ,      ( %d )\n", MAX_N_INT_MSG );
         break;
      case 5:
         printf( "    ,      ( %d )\n", MAX_N_EXT_MSG );
         break;
      case 6:
         printf( "  \n" );
         break;
      case 7:
         printf( "   \n" );
         break;
      case 8:
         printf( "    \n" );
         break;
      case 9:
         printf( "    \n" );
         break;
      case 10:
         printf( "    \n" );
         break;
      case 11:
         printf( "    \n" );
         break;
      case 12:
         printf( "   \n" );
         break;
   }
   
   fflush( stdout );


   if( y0 != 7 ) {
      printf( "A0    %d   :   ", y0 );
   }
   

   switch( y0 ) {
       case 0 :
          printf( " \n\n" );
          break;
       case 1 :
          printf( "    \n\n" );
          break;
       case 2 :
          printf( "    \n\n" );
          break;
       case 6 :
          printf( "    \n" );
          printf("     = '%s'\n",
                           ( char* )message_int.message );
          printf("       %d.%d.%d.%d\n\n",
                           ( message_int.ipaddr >> 24 ) % 256,
                           ( message_int.ipaddr >> 16 ) % 256,
                           ( message_int.ipaddr >> 8 ) % 256,
                           ( message_int.ipaddr) % 256 );
          break;
       case 4 :
          printf( "    \n\n" );
          break;
       case 5 :
          printf( "    \n\n" );
          break;
       case 3 :
          printf( "    \n" );
          printf("     = '%s'\n",
                           ( char* )message_ext.message );
          printf("      = %d.%d.%d.%d\n\n",
                           ( message_ext.ipaddr >> 24 ) % 256,
                           ( message_ext.ipaddr >> 16 ) % 256,
                           ( message_ext.ipaddr >> 8 ) % 256,
                           ( message_ext.ipaddr) % 256 );

          break;
       case 7 :
          printf( "  \n" );
          break;
       default :
          printf( " \n\n" );
          break;
    }
    fflush( stdout );
}


void A0( void )
{

   if( e == 6 ) { y0 = 7; };

   log();
   switch( y0 ) {
      case 0:
         z0();
         if( e == 0 ) { y0 = 1; break; };
         if( e == 1 ) { y0 = 4; break; };
         break;
      case 1:
         if( e == 4 ) { y0 = 4; break; };
         z1();
         if( e == 2 ) { y0 = 0; break; };
         if( e == 7 ) { y0 = 2; break; };
         break;
      case 2:
         z2();
         if( e == 8 ) { y0 = 3; break; };
         break;
      case 3:
         z3();
         if( e == 9 ) { y0 = 1; break; };
         break;
      case 4:
         if( e == 5 ) { y0 = 1; break; };
         z4();
         if( e == 3 ) { y0 = 0; break; };
         if( e == 10 ) { y0 = 5; break; };
         break;
      case 5:
         z5();
         if( e == 11 ) { y0 = 6; break; }
         break;
      case 6:
         z6();
         if( e == 12 ) { y0 = 4; break; }
         break;
      case 7:
         z7();
         break;
      default:
         y0 = 7;
         break;

   }
}

void z0( void ) {
   n_int_msg = 0;
   n_ext_msg = 0;

   pollres = poll( sockets, 2, -1 );

   if( sockets[0].revents & ( POLLERR | POLLHUP ) ) {
      perror( "Internal socket failed" );
      e = 6;
      return;
   }

   if( sockets[1].revents & ( POLLERR | POLLHUP ) ) {
      perror( "External socket failed" );
      e = 6;
      return;
   }


   if( sockets[0].revents & ( POLLIN | POLLPRI ) ) {
      e = 0;
      return;
   }

   if( sockets[1].revents & ( POLLIN | POLLPRI ) ) {
      e = 1;
      return;
   }

   e = 6;
}

void z1( void ) {
   int nbytes;

   errno = 0;

   if( n_int_msg >= MAX_N_INT_MSG ) {
      e = 4;
      n_int_msg = 0;
      return;
   }

   n_int_msg++;

   bzero( message_int.message, sizeof( message_int.message ) );

   nbytes = recv( int_socket, &message_int, sizeof( message_int ), MSG_DONTWAIT );

   if( errno == EAGAIN ) {
      e = 2;
      return;
   }

   if(  nbytes < 0 ) {
      perror( "Error in receiving message from local socket" );
      e = 6;
      return;
   }

   e = 7;
   return;
}

void z2( void ) {
   message_ext.ipaddr = message_int.ipaddr;
   sprintf( message_ext.message, "%s", message_int.message );
   e = 8;
   return;
}

void z3( void ) {
   struct sockaddr_in clnt_addr;
   int caddrlen = sizeof( struct sockaddr_in );

   clnt_addr.sin_family = AF_INET;
   clnt_addr.sin_port = htons( ( u_short )EXT_SOCKET_PORT );
   clnt_addr.sin_addr.s_addr = htonl( message_ext.ipaddr );

   if( sendto( ext_socket, message_ext.message,
        strlen( message_ext.message ) + 1, 0,
        ( struct sockaddr* )&clnt_addr, caddrlen ) < 0 ) {
      perror( "Error in sending message to network" );
      e = 6;
      return;
   }
   e = 9;
   return;
}

void z4( void ) {

   struct sockaddr_in clnt_addr;
   int caddrlen = sizeof( struct sockaddr_in );
   int len;

   errno = 0;

   if( n_ext_msg >= MAX_N_EXT_MSG ) {
      e = 5;
      n_ext_msg = 0;
      return;
   }

   n_ext_msg++;

   bzero( message_ext.message, sizeof( message_ext.message ) );

   len = recvfrom( ext_socket, message_ext.message, sizeof( message_ext.message ),
          MSG_DONTWAIT, ( struct sockaddr* )&clnt_addr, &caddrlen );

   if( errno == EAGAIN ) {
      e = 3;
      return;
   }

   if( len < 0 ) {
      perror( "Error in receiving message from network" );
      e = 6;
      return;
   }

   message_ext.ipaddr = ntohl( clnt_addr.sin_addr.s_addr );

   e = 10;
   return;
}


void z5( void ) {
   message_int.ipaddr = message_ext.ipaddr;
   sprintf( message_int.message, "%s", message_ext.message );
   e = 11;
   return;
}

void z6( void ) {

   if( send( int_socket, &message_int,
       strlen( message_int.message ) + sizeof( message_int.ipaddr ) + 1, 0 ) < 0 ) {
      perror( "Error in sending message through local socket" );
      e = 6;
      return;
   }

   e = 12;
   return;
}



void z7( void ) {
   close( int_socket );
   close( ext_socket );
   unlink( INT_SOCKET_PATH );
}


int main( void ) {
   printf( "\n \n\n" );
   printf( "   ..." );
   
   int_socket = init_int_socket();
   ext_socket = init_ext_socket();

   printf( " \n\n" );

   e = -1;
   if( !int_socket || !ext_socket ) {
      e = 6;
   }
   
   sockets[0].fd = int_socket;
   sockets[1].fd = ext_socket;

   sockets[0].events = POLLIN | POLLPRI;
   sockets[1].events = POLLIN | POLLPRI;

   y0 = 0;

   while( y0 != 7 ) {
      A0();
   }
   
   return 0;
}

