/***************************************************************************
                          schat_deamon_utils.c  -  description
                             -------------------
    begin                :   21 2004
    copyright            : (C) 2004 by Evgeny Kalugin
    email                : kalugin@ake-vg.spb.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <unistd.h>
#include <stdio.h>


#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>


#include "schat_deamon.h"



int init_int_socket( void ) {

   struct sockaddr_un addr;
   int sockfd, csockfd;

   unlink( INT_SOCKET_PATH );

   sockfd = socket( AF_UNIX, SOCK_STREAM, 0 );

   if( sockfd <= 0 ) {
      perror( "Error in creating local socket" );
      goto fail;
   }

   addr.sun_family = AF_UNIX;
   strcpy( addr.sun_path, INT_SOCKET_PATH );

   if( bind( sockfd, ( struct sockaddr* )&addr, sizeof( addr ) ) ) {
      perror( "Error in binding local socket" );
      goto fail;
   }

   if( listen( sockfd, 1 ) ) {
      perror( "Error while listening local socket" );
      goto fail;
   }

   csockfd = accept( sockfd, NULL, NULL );

   if( csockfd <= 0 ) {
      perror( "Error in accepting local connection" );
      goto fail;
   }

   if( close( sockfd ) != 0 ) {
      perror( "Error in closing parent local socket" );
   }

   return csockfd;

 fail:

   return 0;
}


int init_ext_socket( void ) {

   struct sockaddr_in addr;
   int sockfd;

   sockfd = socket( AF_INET, SOCK_DGRAM, IPPROTO_UDP );

   if( sockfd <= 0 ) {
      perror( "Error in creating network socket" );
      goto fail;
   }

   addr.sin_family = AF_INET;
   addr.sin_port = htons( ( u_short )EXT_SOCKET_PORT );
   addr.sin_addr.s_addr = INADDR_ANY;

   if( bind( sockfd, ( struct sockaddr* )&addr, sizeof( addr ) ) ) {
      perror( "Error in binding network socket" );
      goto fail;
   }

   return sockfd;

 fail:

   return 0;
}
